using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_HotelPuntoVenta._1_Datos
{
    public class HPV_Terminales_ValidacionesHistorico_Datos
    {
        #region Modelos

        #region Modelo Listado
        private List<HPV_Terminales_ValidacionesHistorico> g_lst_HPV_Terminales_ValidacionesHistorico = null;

        public List<HPV_Terminales_ValidacionesHistorico> Obtener_ModeloListado_Por_IdTerminal(long _lng_idTerminal)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE  " + nameof(HPV_Terminales_ValidacionesHistorico) + "." + nameof(HPV_Terminales_ValidacionesHistorico.idTerminal) + "=@idTerminal ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idTerminal",  _lng_idTerminal)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Terminales_ValidacionesHistorico_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdTerminal), true);
            }

            return g_lst_HPV_Terminales_ValidacionesHistorico;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_HPV_Terminales_ValidacionesHistorico = obj_Exferia_Entities.Database.SqlQuery<HPV_Terminales_ValidacionesHistorico>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_Terminales_ValidacionesHistorico_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
               " SELECT " +
                   nameof(HPV_Terminales_ValidacionesHistorico.id) + "," +
                   nameof(HPV_Terminales_ValidacionesHistorico.clave) + "," +
                   nameof(HPV_Terminales_ValidacionesHistorico.fechaHora) + "," +
                   nameof(HPV_Terminales_ValidacionesHistorico.idTerminal) + "," +
                   nameof(HPV_Terminales_ValidacionesHistorico.MAC) +
               " FROM " + nameof(HPV_Terminales_ValidacionesHistorico);
        }
        #endregion
    }
}
